.nolist
include \masm32\include\masm32rt.inc
.686
include \masm32\macros\timers.asm			; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]
LOOP_COUNT	= 1600000		; 1600000 equals cycles and ticks for 1.6 GHz

.code
start:
	push 1
	call ShowCpu	; print brand string and SSE level
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 100
		mov eax, 1000
		imul eax, eax, 8
		mov esi, eax
		ENDM
	counter_end
	print str$(eax), 9, "cycles for 100*imul 8", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov ecx, 8
		REPEAT 100
		mov eax, 1000
		mul ecx
		mov esi, eax
		ENDM
	counter_end
	print str$(eax), 9, "cycles for 100*mul 8", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 100
		mov eax, 1000
		shl eax, 3
		mov esi, eax
		ENDM
	counter_end
	print str$(eax), 9, "cycles for 100*shl 3", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 100
		mov eax, 1000
		shl eax, 1
		mov esi, eax
		ENDM
	counter_end
	print str$(eax), 9, "cycles for 100*shl 1", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 100
		mov eax, 1000
		imul eax, eax, 10
		mov esi, eax
		ENDM
	counter_end
	print str$(eax), 9, "cycles for 100*imul 10", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov ecx, 10
		REPEAT 100
		mov eax, 1000
		mul ecx
		mov esi, eax
		ENDM
	counter_end
	print str$(eax), 9, "cycles for 100*mul 10", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 100
		mov eax, 1000
		lea eax, [eax+4*eax]
		add eax, eax
		mov esi, eax
		ENDM
	counter_end
	print str$(eax), 9, "cycles for 100*lea mul10", 13, 10, 10

	timer_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 100
		mov eax, 1000
		imul eax, eax, 8
		mov esi, eax
		ENDM
	timer_end
	print str$(eax), 9, "ticks for 100*imul 8", 13, 10

	timer_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov ecx, 8
		REPEAT 100
		mov eax, 1000
		mul ecx
		mov esi, eax
		ENDM
	timer_end
	print str$(eax), 9, "ticks for 100*mul 8", 13, 10

	timer_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 100
		mov eax, 1000
		shl eax, 3
		mov esi, eax
		ENDM
	timer_end
	print str$(eax), 9, "ticks for 100*shl 3", 13, 10

	timer_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 100
		mov eax, 1000
		shl eax, 1
		mov esi, eax
		ENDM
	timer_end
	print str$(eax), 9, "ticks for 100*shl 1", 13, 10

	timer_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 100
		mov eax, 1000
		imul eax, eax, 10
		mov esi, eax
		ENDM
	timer_end
	print str$(eax), 9, "ticks for 100*imul 10", 13, 10

	timer_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		mov ecx, 10
		REPEAT 100
		mov eax, 1000
		mul ecx
		mov esi, eax
		ENDM
	timer_end
	print str$(eax), 9, "ticks for 100*mul 10", 13, 10

	timer_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 100
		mov eax, 1000
		lea eax, [eax+4*eax]
		add eax, eax
		mov esi, eax
		ENDM
	timer_end
	print str$(eax), 9, "ticks for 100*lea mul10", 13, 10

	inkey chr$(13, 10, "--- ok ---", 13)
	exit

ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]